	sect 0
_CreateData:
	pshx
	pshx
	tsx
 sei

	ldd  _last
	std 2,x
	addd #1
	std  _last
	ldd 2,x
	cpd #100
	beq X0.thread
	jmp  L2.thread
X0.thread:
	ldd #L4.thread
	std 0,x
	jsr  _OutString
	tsx
	ldd #13
	std 0,x
	jsr  _OutChar
	tsx
 stop

 cli

L2.thread:
	ldd  _last
	pulx
	pulx
	rts
L1.thread:
_pseudo:
;        i -> 0,x
;  loopcnt -> 4,x
	pshx
	tsx
	ldd #0
	std 0,x
	jmp  L10.thread
L7.thread:
L8.thread:
	ldd 0,x
	addd #1
	std 0,x
L10.thread:
	ldd 0,x
	cpd 4,x
	blo  L7.thread
	pulx
	rts
L6.thread:
_Message:
;     data -> 8,x
;   NamePt -> 6,x
; threadId -> 4,x
	pshx
	tsx
	ldd #_DisplayFree
	std 0,x
	jsr  _Wait
	tsx
	ldd 4,x
	std 0,x
	jsr  _OutUDec
	tsx
	ldd 6,x
	std 0,x
	jsr  _OutString
	tsx
	ldd 8,x
	std 0,x
	jsr  _OutUDec
	tsx
	ldd #13
	std 0,x
	jsr  _OutChar
	tsx
	ldd #_DisplayFree
	std 0,x
	jsr  _Signal
	tsx
	pulx
	rts
L11.thread:
_Producer:
;        x -> 6,x
;     myId -> 8,x
	pshx
	pshx
	pshx
	pshx
	pshx
	tsx
	ldd  _RunPt
	addd #4
	xgdy
	ldab 0,y
	clra
	std 8,x
L13.thread:
L14.thread:
	ldab #4
	stab  4099
	jsr  _CreateData
	tsx
	std 6,x
	std 0,x
	jsr  _pseudo
	tsx
	ldd 8,x
	std 0,x
	ldd #L16.thread
	std 2,x
	ldd 6,x
	std 4,x
	jsr  _Message
	tsx
	ldd 6,x
	std 0,x
	jsr  _Put
	tsx
	jmp  L13.thread
L12.thread:
_Consumer:
;     myId -> 6,x
;        x -> 8,x
	pshx
	pshx
	pshx
	pshx
	pshx
	tsx
	ldd  _RunPt
	addd #4
	xgdy
	ldab 0,y
	clra
	std 6,x
L18.thread:
L19.thread:
	ldab #8
	stab  4099
	jsr  _Get
	tsx
	std 8,x
	std 0,x
	jsr  _pseudo
	tsx
	ldd 6,x
	std 0,x
	ldd #L21.thread
	std 2,x
	ldd 8,x
	std 4,x
	jsr  _Message
	tsx
	jmp  L18.thread
L17.thread:
	sect 1
_sys:
	FDB _sys+80
	FDB _sys+5+65
	FCB 1
	FCB 0
	RMB 65
	FCB 64
	FCB 0
	FCB 0
	FDB 0x0
	FDB 0x0
	FDB _Producer
	FDB _sys+160
	FDB _sys+80+5+65
	FCB 2
	FCB 0
	RMB 65
	FCB 64
	FCB 0
	FCB 0
	FDB 0x0
	FDB 0x0
	FDB _Producer
	FDB _sys+240
	FDB _sys+160+5+65
	FCB 4
	FCB 0
	RMB 65
	FCB 64
	FCB 0
	FCB 0
	FDB 0x0
	FDB 0x0
	FDB _Consumer
	FDB _sys
	FDB _sys+240+5+65
	FCB 8
	FCB 0
	RMB 65
	FCB 64
	FCB 0
	FCB 0
	FDB 0x0
	FDB 0x0
	FDB _Consumer
	sect 0
_IncTime:
	pshx
	tsx
	ldd  _ElapsedTime
	std 0,x
	addd #1
	std  _ElapsedTime
	ldd 0,x
	cpd #0
	bne  L37.thread
	ldd #-1
	std  _ElapsedTime
L37.thread:
	pulx
	rts
L36.thread:
_ThreadSwitch:
 ldx _RunPt
 sts 2,x

	jsr  _IncTime
	ldy  _RunPt
	ldd 0,y
	std  _RunPt
	addd #4
	xgdy
	ldab 0,y
	stab  4100
 ldx _RunPt
 lds 2,x

	ldd  4110
	addd #1000
	std  4122
	ldab #32
	stab  4131
 rti

	rts
L40.thread:
_main:
	pshx
	tsx
	jsr  _InitSCI
	tsx
	ldab #255
	stab  4103
	ldd #1
	std  _DisplayFree
	ldd #0
	std  _last
	ldd #0
	std  _ElapsedTime
	ldd #L42.thread
	std 0,x
	jsr  _OutString
	tsx
	ldd #13
	std 0,x
	jsr  _OutChar
	tsx
	ldd #_sys
	std  _RunPt
  sei

	jsr  _InitFifo
	tsx
	ldab #32
	stab  4131
	ldab #32
	stab  4130
	ldd  4110
	addd #1000
	std  4122
	ldd  _RunPt
	addd #4
	xgdy
	ldab 0,y
	stab  4100
  ldx _RunPt
  lds 2,x
  cli
  rti

	pulx
	rts
L41.thread:
_InitSCI:
	jsr  _RxInitFifo
	jsr  _TxInitFifo
	ldab #0
	stab  4140
	ldab #44
	stab  4141
	ldab #0
	stab  4139
 cli

	rts
L43.thread:
_InChar:
;   letter -> 2,x
	pshx
	pshx
	tsx
L45.thread:
L46.thread:
	xgdx
	tsx
	addd #2
	std 0,x
	jsr  _RxGetFifo
	tsx
	cpd #0
	beq  L45.thread
	ldab 2,x
	clra
	tstb
	bpl X1.thread
	coma
X1.thread:
	pulx
	pulx
	rts
L44.thread:
_OutChar:
;     data -> 4,x
	pshx
	tsx
	ldd 4,x
	stab 4,x
	ldab 4,x
	clra
	tstb
	bpl X2.thread
	coma
X2.thread:
	std 0,x
	jsr  _TxPutFifo
	tsx
	ldab #172
	stab  4141
	pulx
	rts
L48.thread:
_RDRFHandler:
	pshx
	tsx
	ldab  4143
	clra
	clra
	clra
	tstb
	bpl X3.thread
	coma
X3.thread:
	std 0,x
	jsr  _RxPutFifo
	tsx
	pulx
	rts
L49.thread:
_TDREHandler:
;   letter -> 2,x
	pshx
	pshx
	tsx
	xgdx
	tsx
	addd #2
	std 0,x
	jsr  _TxGetFifo
	tsx
	cpd #0
	beq  L51.thread
	ldab 2,x
	clra
	tstb
	bpl X4.thread
	coma
X4.thread:
	stab  4143
	jmp  L52.thread
L51.thread:
	ldab #44
	stab  4141
L52.thread:
	pulx
	pulx
	rts
L50.thread:
_SciHandler:
	ldab  4142
	clra
	andb #32
	clra
	cpd #0
	beq  L54.thread
	jsr  _RDRFHandler
L54.thread:
	ldab  4142
	clra
	andb #128
	clra
	cpd #0
	bne X5.thread
	jmp  L56.thread
X5.thread:
	jsr  _TDREHandler
 rti

L56.thread:
	rts
L53.thread:
_InStatus:
	ldab  4142
	clra
	andb #32
	clra
	clra
	clra
	rts
L58.thread:
_OutStatus:
	ldab  4142
	clra
	andb #128
	clra
	clra
	clra
	rts
L59.thread:
_UpCase:
; character -> 6,x
	pshx
	pshx
	tsx
	ldd 6,x
	stab 6,x
	ldab 6,x
	clra
	tstb
	bpl X6.thread
	coma
X6.thread:
	std 0,x
	cpd #97
	blt  L62.thread
	ldd 0,x
	cpd #122
	bgt  L62.thread
	ldab 6,x
	clra
	tstb
	bpl X7.thread
	coma
X7.thread:
	subd #32
	std 2,x
	jmp  L63.thread
L62.thread:
	ldab 6,x
	clra
	tstb
	bpl X8.thread
	coma
X8.thread:
	std 2,x
L63.thread:
	ldd 2,x
	clra
	clra
	tstb
	bpl X9.thread
	coma
X9.thread:
	pulx
	pulx
	rts
L60.thread:
_InUDec:
; character -> 6,x
;   length -> 8,x
;   number -> 10,x
	tsx
	xgdx
	subd #12
	xgdx
	txs
	ldd #0
	std 10,x
	ldd #0
	std 8,x
	jmp  L67.thread
L66.thread:
	ldab 6,x
	clra
	std 4,x
	cpd #48
	blt  L69.thread
	ldd 4,x
	cpd #57
	bgt  L69.thread
	ldd #10
	ldy 10,x
	jsr  __mulu
	pshb
	psha
	ldab 6,x
	clra
	std 2,x
	tsy
	addd 0,y
	puly
	subd #48
	std 10,x
	ldd 8,x
	addd #1
	std 8,x
	ldd 2,x
	clra
	clra
	tstb
	bpl X10.thread
	coma
X10.thread:
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L70.thread
L69.thread:
	ldab 6,x
	clra
	cpd #8
	bne  L71.thread
	ldd 8,x
	cpd #0
	beq  L71.thread
	ldd 10,x
	ldx #10
	idiv
	xgdx
	tsx
	std 10,x
	ldd 8,x
	subd #1
	std 8,x
	ldab 6,x
	clra
	clra
	clra
	tstb
	bpl X11.thread
	coma
X11.thread:
	std 0,x
	jsr  _OutChar
	tsx
L71.thread:
L70.thread:
L67.thread:
	jsr  _InChar
	tsx
	clra
	tstb
	bpl X12.thread
	coma
X12.thread:
	clra
	std 2,x
	stab 6,x
	ldd 2,x
	clra
	cpd #13
	beq X13.thread
	jmp  L66.thread
X13.thread:
	ldd 10,x
	xgdx
	addd #12
	xgdx
	txs
	rts
L65.thread:
_InSDec:
; character -> 6,x
;     sign -> 8,x
;   number -> 10,x
;   length -> 12,x
	tsx
	xgdx
	subd #14
	xgdx
	txs
	ldd #0
	std 10,x
	ldd #1
	std 8,x
	ldd #0
	std 12,x
	jmp  L78.thread
L77.thread:
	ldd 12,x
	cpd #0
	bne  L80.thread
	ldab 6,x
	clra
	cpd #45
	bne  L82.thread
	ldd #-1
	std 8,x
	ldd 12,x
	addd #1
	std 12,x
	ldd #45
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L83.thread
L80.thread:
	ldab 6,x
	clra
	std 4,x
	cpd #48
	blt  L86.thread
	ldd 4,x
	cpd #57
	bgt  L86.thread
	ldd #10
	ldy 10,x
	jsr  __muli
	pshb
	psha
	ldab 6,x
	clra
	std 2,x
	tsy
	addd 0,y
	puly
	subd #48
	std 10,x
	ldd 12,x
	addd #1
	std 12,x
	ldd 2,x
	clra
	clra
	tstb
	bpl X14.thread
	coma
X14.thread:
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L87.thread
L82.thread:
	ldab 6,x
	clra
	cpd #43
	bne  L84.thread
	ldd 12,x
	addd #1
	std 12,x
	ldd #43
	std 0,x
	jsr  _OutChar
	tsx
L84.thread:
L83.thread:
	jmp  L80.thread
L86.thread:
	ldab 6,x
	clra
	cpd #8
	bne  L88.thread
	ldd 12,x
	cpd #0
	beq  L88.thread
	ldd 10,x
	ldy #10
	jsr  __divi
	std 10,x
	ldd 12,x
	subd #1
	std 12,x
	cpd #0
	bne  L90.thread
	ldd #1
	std 8,x
	jmp  L90.thread
L88.thread:
	jmp  L87.thread
L90.thread:
	ldd #8
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L88.thread
L87.thread:
L78.thread:
	jsr  _InChar
	tsx
	clra
	tstb
	bpl X15.thread
	coma
X15.thread:
	clra
	std 4,x
	stab 6,x
	ldd 4,x
	clra
	cpd #13
	beq X16.thread
	jmp  L77.thread
X16.thread:
	ldd 8,x
	ldy 10,x
	jsr  __muli
	xgdx
	addd #14
	xgdx
	txs
	rts
L76.thread:
_OutUDec:
;   number -> 4,x
	pshx
	tsx
	ldd 4,x
	cpd #10
	blo  L96.thread
	ldd 4,x
	ldx #10
	idiv
	xgdx
	tsx
	std 0,x
	jsr  _OutUDec
	tsx
	ldd 4,x
	ldx #10
	idiv
	tsx
	std 0,x
	jsr  _OutUDec
	tsx
	jmp  L97.thread
L96.thread:
	ldd 4,x
	addd #48
	clra
	clra
	tstb
	bpl X17.thread
	coma
X17.thread:
	std 0,x
	jsr  _OutChar
	tsx
L97.thread:
	pulx
	rts
L95.thread:
_OutSDec:
;   number -> 4,x
	pshx
	tsx
	ldd 4,x
	cpd #0
	bge  L99.thread
	ldd 4,x
	nega
	negb
	sbca #0
	std 4,x
	ldd #45
	std 0,x
	jsr  _OutChar
	tsx
L99.thread:
	ldd 4,x
	std 0,x
	jsr  _OutUDec
	tsx
	pulx
	rts
L98.thread:
_InUHex:
; character -> 6,x
;   length -> 8,x
;   number -> 10,x
;    digit -> 12,x
	tsx
	xgdx
	subd #14
	xgdx
	txs
	ldd #0
	std 10,x
	ldd #0
	std 8,x
	jmp  L103.thread
L102.thread:
	ldd #16
	std 12,x
	ldab 6,x
	clra
	std 4,x
	cpd #48
	blt  L105.thread
	ldd 4,x
	cpd #57
	bgt  L105.thread
	ldab 6,x
	clra
	subd #48
	std 12,x
	jmp  L106.thread
L105.thread:
	ldab 6,x
	clra
	std 2,x
	cpd #65
	blt  L107.thread
	ldd 2,x
	cpd #70
	bgt  L107.thread
	ldab 6,x
	clra
	subd #65
	addd #10
	std 12,x
L107.thread:
L106.thread:
	ldd 12,x
	cpd #15
	bhi  L109.thread
	ldd 10,x
	lsld
	lsld
	lsld
	lsld
	addd 12,x
	std 10,x
	ldd 8,x
	addd #1
	std 8,x
	ldab 6,x
	clra
	clra
	clra
	tstb
	bpl X18.thread
	coma
X18.thread:
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L110.thread
L109.thread:
	ldab 6,x
	clra
	cpd #8
	bne  L111.thread
	ldd 8,x
	cpd #0
	beq  L111.thread
	ldd 10,x
	lsrd
	lsrd
	lsrd
	lsrd
	std 10,x
	ldd 8,x
	subd #1
	std 8,x
	ldab 6,x
	clra
	clra
	clra
	tstb
	bpl X19.thread
	coma
X19.thread:
	std 0,x
	jsr  _OutChar
	tsx
L111.thread:
L110.thread:
L103.thread:
	jsr  _InChar
	tsx
	clra
	tstb
	bpl X20.thread
	coma
X20.thread:
	std 0,x
	jsr  _UpCase
	tsx
	clra
	tstb
	bpl X21.thread
	coma
X21.thread:
	clra
	std 4,x
	stab 6,x
	ldd 4,x
	clra
	cpd #13
	beq X22.thread
	jmp  L102.thread
X22.thread:
	ldd 10,x
	xgdx
	addd #14
	xgdx
	txs
	rts
L101.thread:
_OutUHex:
;   number -> 4,x
	pshx
	tsx
	ldd 4,x
	cpd #16
	blo  L117.thread
	ldd 4,x
	lsrd
	lsrd
	lsrd
	lsrd
	std 0,x
	jsr  _OutUHex
	tsx
	ldd 4,x
	andb #15
	clra
	std 0,x
	jsr  _OutUHex
	tsx
	jmp  L118.thread
L117.thread:
	ldd 4,x
	cpd #10
	bhs  L119.thread
	ldd 4,x
	addd #48
	clra
	clra
	tstb
	bpl X23.thread
	coma
X23.thread:
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L120.thread
L119.thread:
	ldd 4,x
	subd #10
	addd #65
	clra
	clra
	tstb
	bpl X24.thread
	coma
X24.thread:
	std 0,x
	jsr  _OutChar
	tsx
L120.thread:
L118.thread:
	pulx
	rts
L116.thread:
_InString:
;   length -> 4,x
; character -> 6,x
;      max -> 12,x
;   string -> 10,x
	pshx
	pshx
	pshx
	pshx
	tsx
	ldd #0
	std 4,x
	jmp  L123.thread
L122.thread:
	ldab 6,x
	clra
	cpd #8
	bne  L125.thread
	ldd 4,x
	cpd #0
	beq  L125.thread
	ldd 10,x
	addd #-1
	std 10,x
	ldd 4,x
	subd #1
	std 4,x
	ldd #8
	std 0,x
	jsr  _OutChar
	tsx
	jmp  L126.thread
L125.thread:
	ldd 4,x
	cpd 12,x
	bhs  L127.thread
	ldd 10,x
	std 2,x
	addd #1
	std 10,x
	ldab 6,x
	ldy 2,x
	stab 0,y
	ldd 4,x
	addd #1
	std 4,x
	ldab 6,x
	clra
	clra
	clra
	tstb
	bpl X25.thread
	coma
X25.thread:
	std 0,x
	jsr  _OutChar
	tsx
L127.thread:
L126.thread:
L123.thread:
	jsr  _InChar
	tsx
	clra
	tstb
	bpl X26.thread
	coma
X26.thread:
	clra
	std 2,x
	stab 6,x
	ldd 2,x
	clra
	cpd #13
	bne  L122.thread
	ldab #0
	ldy 10,x
	stab 0,y
	pulx
	pulx
	pulx
	pulx
	rts
L121.thread:
_OutString:
;   letter -> 6,x
;       pt -> 10,x
	pshx
	pshx
	pshx
	pshx
	tsx
	jmp  L133.thread
L132.thread:
	ldab 6,x
	clra
	tstb
	bpl X27.thread
	coma
X27.thread:
	std 0,x
	jsr  _OutChar
	tsx
L133.thread:
	ldd 10,x
	std 4,x
	addd #1
	std 10,x
	ldy 4,x
	ldab 0,y
	std 2,x
	stab 6,x
	ldd 2,x
	clra
	tstb
	bpl X28.thread
	coma
X28.thread:
	cpd #0
	bne  L132.thread
	pulx
	pulx
	pulx
	pulx
	rts
L131.thread:
_RxInitFifo:
	ldd #_RxFifo
	std  _RxGetPt
	ldd #_RxFifo
	std  _RxPutPt
	rts
L137.thread:
_RxPutFifo:
;   tempPt -> 2,x
;     data -> 6,x
	pshx
	pshx
	tsx
	ldd 6,x
	stab 6,x
	ldd  _RxPutPt
	std 2,x
	std 0,x
	addd #1
	std 2,x
	ldab 6,x
	ldy 0,x
	stab 0,y
	ldd 2,x
	cpd #_RxFifo+3
	bne  L139.thread
	ldd #_RxFifo
	std 2,x
L139.thread:
	ldd 2,x
	cpd  _RxGetPt
	bne  L142.thread
	ldd #0
	pulx
	pulx
	rts
L142.thread:
	ldd 2,x
	std  _RxPutPt
	ldd #1
	pulx
	pulx
	rts
L138.thread:
_RxGetFifo:
;   datapt -> 4,x
	pshx
	tsx
	ldd  _RxPutPt
	cpd  _RxGetPt
	bne  L146.thread
	ldd #0
	pulx
	rts
L146.thread:
 sei

	ldd  _RxGetPt
	std 0,x
	addd #1
	std  _RxGetPt
	ldy 0,x
	ldab 0,y
	ldy 4,x
	stab 0,y
	ldd  _RxGetPt
	cpd #_RxFifo+3
	beq X29.thread
	jmp  L148.thread
X29.thread:
	ldd #_RxFifo
	std  _RxGetPt
 cli

L148.thread:
	ldd #1
	pulx
	rts
L145.thread:
_TxInitFifo:
	ldd #_TxFifo
	std  _TxGetPt
	ldd #_TxFifo
	std  _TxPutPt
	rts
L152.thread:
_TxPutFifo:
;   tempPt -> 2,x
;     data -> 6,x
	pshx
	pshx
	tsx
	ldd 6,x
	stab 6,x
 sei

	ldd  _TxPutPt
	std 2,x
	std 0,x
	addd #1
	std 2,x
	ldab 6,x
	ldy 0,x
	stab 0,y
	ldd 2,x
	cpd #_TxFifo+3
	bne  L154.thread
	ldd #_TxFifo
	std 2,x
L154.thread:
	ldd 2,x
	cpd  _TxGetPt
	beq X30.thread
	jmp  L157.thread
X30.thread:
 cli

	ldd #0
	pulx
	pulx
	rts
L157.thread:
	ldd 2,x
	std  _TxPutPt
 cli

	ldd #1
	pulx
	pulx
	rts
L153.thread:
_TxGetFifo:
;   datapt -> 4,x
	pshx
	tsx
	ldd  _TxPutPt
	cpd  _TxGetPt
	bne  L161.thread
	ldd #0
	pulx
	rts
L161.thread:
	ldd  _TxGetPt
	std 0,x
	addd #1
	std  _TxGetPt
	ldy 0,x
	ldab 0,y
	ldy 4,x
	stab 0,y
	ldd  _TxGetPt
	cpd #_TxFifo+3
	bne  L163.thread
	ldd #_TxFifo
	std  _TxGetPt
L163.thread:
	ldd #1
	pulx
	rts
L160.thread:
_Wait:
; semaphore -> 4,x
	pshx
	tsx
 sei

	ldab  4099
	clra
	orab #16
	stab  4099
	jmp  L169.thread
L168.thread:
 cli
 nop
 sei

L169.thread:
	ldy 4,x
	ldd 0,y
	cpd #0
	bgt X31.thread
	jmp  L168.thread
X31.thread:
	ldd 4,x
	std 0,x
	xgdy
	ldd 0,y
	subd #1
	ldy 0,x
	std 0,y
	ldab  4099
	clra
	andb #239
	stab  4099
 cli

	pulx
	rts
L167.thread:
_Signal:
; semaphore -> 4,x
	pshx
	tsx
 sei

	ldab  4099
	clra
	orab #32
	stab  4099
	ldd 4,x
	std 0,x
	xgdy
	ldd 0,y
	addd #1
	ldy 0,x
	std 0,y
	ldab  4099
	clra
	andb #223
	stab  4099
 cli

	pulx
	rts
L172.thread:
_InitFifo:
	ldd #4
	std  _RoomLeft
	ldd #0
	std  _Available
	ldd #_Fifo
	std  _GetPt
	ldd #_Fifo
	std  _PutPt
	rts
L174.thread:
_Put:
;     data -> 6,x
	pshx
	pshx
	tsx
	ldd #_RoomLeft
	std 0,x
	jsr  _Wait
	tsx
 sei

	ldab  4099
	clra
	orab #1
	stab  4099
	ldd  _PutPt
	std 2,x
	addd #2
	std  _PutPt
	ldd 6,x
	ldy 2,x
	std 0,y
	ldd  _PutPt
	cpd #_Fifo+10
	bne  L176.thread
	ldd #_Fifo
	std  _PutPt
L176.thread:
	ldab  4099
	clra
	andb #254
	stab  4099
 cli

	ldd #_Available
	std 0,x
	jsr  _Signal
	tsx
	pulx
	pulx
	rts
L175.thread:
_Get:
;     data -> 4,x
	pshx
	pshx
	pshx
	tsx
	ldd #_Available
	std 0,x
	jsr  _Wait
	tsx
 sei

	ldab  4099
	clra
	orab #2
	stab  4099
	ldd  _GetPt
	std 2,x
	addd #2
	std  _GetPt
	ldy 2,x
	ldd 0,y
	std 4,x
	ldd  _GetPt
	cpd #_Fifo+10
	bne  L181.thread
	ldd #_Fifo
	std  _GetPt
L181.thread:
	ldab  4099
	clra
	andb #253
	stab  4099
 cli

	ldd #_RoomLeft
	std 0,x
	jsr  _Signal
	tsx
	ldd 4,x
	pulx
	pulx
	pulx
	rts
L180.thread:
_resetVectors:
 org $FFD6

 FDB _SciHandler

 org $FFE4

 FDB _ThreadSwitch

 org $FFFE

 FDB __start

 org $FC00

	rts
L185.thread:
	sect 1
_Fifo:
	RMB 10
_Available:
	RMB 2
_RoomLeft:
	RMB 2
_GetPt:
	RMB 2
_PutPt:
	RMB 2
_TxFifo:
	RMB 3
_TxGetPt:
	RMB 2
_TxPutPt:
	RMB 2
_RxFifo:
	RMB 3
_RxGetPt:
	RMB 2
_RxPutPt:
	RMB 2
_last:
	RMB 2
_RunPt:
	RMB 2
_DisplayFree:
	RMB 2
_ElapsedTime:
	RMB 2
	sect 0
L42.thread:
	FCB 'F,'i,'x,'e,'d,32,'a,'l,'l,'o,'c,'a,'t,'i,'o,'n
	FCB 32,'s,'p,'i,'n,'l,'o,'c,'k,32,'s,'e,'m,'a,'p,'h
	FCB 'o,'r,'e,32,'s,'y,'s,'t,'e,'m,0
L21.thread:
	FCB 32,'g,'e,'t,'s,32,0
L16.thread:
	FCB 32,'p,'u,'t,'s,32,0
L4.thread:
	FCB 'd,'o,'n,'e,0
